import React from "react";
import { Input } from "@orbit-ui/react-input";
import { PureComponent } from "react";
import { func, node, string } from "prop-types";
export class MultiSelectDropdownSearchInput extends PureComponent {
  constructor(...args) {
    super(...args);

    this.handleChange = (event, {
      value
    }) => {
      const {
        onChange
      } = this.props;
      onChange(event, value, this.props);
    };
  }

  render() {
    const {
      placeholder,
      icon,
      className
    } = this.props;
    return React.createElement(Input, {
      onChange: this.handleChange,
      placeholder: placeholder,
      icon: icon,
      iconPosition: "left",
      className: className,
      autofocus: true,
      autoComplete: "off"
    });
  }

}
MultiSelectDropdownSearchInput.displayName = "MultiSelectDropdownSearchInput";
MultiSelectDropdownSearchInput.propTypes = {
  /**
   * Called on text change.
   * @param {SyntheticEvent} event - React's original SyntheticEvent.
   * @param {string} value - New value.
   * @param {Object} props - All the props.
   * @returns {void}
   */
  onChange: func,

  /**
   * A custom React SVG component displayed before the text.
   */
  icon: node,

  /**
   * The placeholder text.
   */
  placeholder: string,

  /**
   * Additional classes.
   */
  className: string
};